USE [AdventureWorks2012]
GO

SET STATISTICS IO ON
/* 

CREATE NONCLUSTERED INDEX [idx_SalesOrderDetail_ModifiedDate]
ON [Sales].[SalesOrderDetail] ([ModifiedDate])

CREATE NONCLUSTERED INDEX [idx_SalesOrderDetail_ModifiedDate]
ON [Sales].[SalesOrderDetailEnlarged] ([ModifiedDate])
*/

/**************************************************************************************/
SELECT LastName, FirstName, MiddleName
FROM [Person].[Person]
WHERE LastName LIKE '%MITH%'

SELECT LastName, FirstName, MiddleName
FROM [Person].[Person]
WHERE LastName LIKE 'SMI%'

/**************************************************************************************/

SELECT LastName, FirstName, MiddleName  --NVARCHAR(50)
FROM [Person].[Person]
WHERE SUBSTRING(LastName, 1,1) =N'S'

SELECT LastName, FirstName, MiddleName
FROM [Person].[Person]
WHERE LastName LIKE N'S%'

/**************************************************************************************/

GO
SELECT GETDATE()
SELECT CONVERT(VARCHAR(10), GETDATE(), 101) 


SELECT ModifiedDate -- DATETIME
FROM Sales.SalesOrderDetailEnlarged c
WHERE CAST(CONVERT(VARCHAR(10), ModifiedDate, 101) AS DATETIME) = '7/27/2008'

/**************************************************************************************/

SELECT ModifiedDate  --DATETIME
FROM Sales.SalesOrderDetailEnlarged s
WHERE ModifiedDate >= '7/27/2008' AND ModifiedDate < '7/28/2008'


--same result?
SELECT ModifiedDate
FROM Sales.SalesOrderDetail s
WHERE ModifiedDate BETWEEN '7/27/2008' AND '2008-07-28 00:00:00.000'

/**************************************************************************************/

SELECT ModifiedDate  --DATETIME
FROM Sales.SalesOrderDetail s
WHERE YEAR(ModifiedDate) = '2008'

SELECT ModifiedDate
FROM Sales.SalesOrderDetail s
WHERE ModifiedDate >= '1/1/2008' AND ModifiedDate < '1/1/2009'

/**************************************************************************************/

SELECT ModifiedDate --DATETIME
FROM Sales.SalesOrderDetail s
WHERE DATEADD(YEAR, 6, ModifiedDate) < '7/02/2011'

SELECT ModifiedDate
FROM Sales.SalesOrderDetail s
WHERE ModifiedDate < DATEADD(YEAR, -6, '7/02/2011')

----------------------------------------------------------------------------------------
SELECT SalesOrderId -- INT
FROM Sales.SalesOrderHeaderEnlarged
WHERE COALESCE(SalesOrderId, 43662) = 43662

SELECT SalesOrderId
FROM Sales.SalesOrderHeaderEnlarged
WHERE ISNULL(SalesOrderId, 43662) = 43662

SELECT SalesOrderId 
FROM Sales.SalesOrderHeaderEnlarged
WHERE SalesOrderId IS NULL OR SalesOrderId  = 79


----------------------------------------------------------------------------------------

SELECT AddressLine1  --NVARCHAR(60)
FROM Person.[Address]
WHERE AddressLine1 = CAST('1, place Beaubernard' AS VARCHAR(60))
GO
---------------------------------------------------------------
SELECT AccountNumber --VARCHAR(10)
FROM Sales.Customer
WHERE AccountNumber = CAST(N'AW00000164' AS NVARCHAR(10))